## RiskyMod
A full-game overhaul that aims to bring it closer to RoR1's balance. My main priority is multiplayer, but the mod is balanced in solo as well. Nearly every change from this mod can be toggled on/off, so you can configure it to your liking!

I highly recommed installing https://thunderstore.io/package/Moffein/EliteReworks/ to go with this.

Full change list can be found at https://docs.google.com/document/d/1Igxdur0M33fdkcDLYgDEbLE0M4-89gSTorxgdn-oyKs/

Feel free to take features of this mod and release them as standalone as long as you link the original GitHub repo in the README.

**Contact me if you're interested in translating the mod!**

## Compatibility

This mod is compatible with nearly all content mods. The only things that will conflict are other mods that modify the Vanilla balance such as FlatItemBuff, but you can make it work by editing your RiskyMod config to disable conflicting features (ex. make sure you dont have both mods trying to modify Leeching Seed).

## Main Features

- Oneshot Protection now actually works.
	- Oneshot = Going from >90% HP to 0% HP in under 0.5s
	- Once triggered, you have to be out of danger (no damage for 7s) before it can be retriggered.
- Shields gate against HP damage like the Guardian's Heart in RoR1.
- Big balance pass over nearly all the items.
	- Bad items like Squid Polyps and Warbanners have gotten substantial buffs.
	- Strong damage items like AtGs and Elemental Bands now have lowered damage stacking.
	- Most forms of range scaling have been removed, and most items aren't able to proc chain anymore.
- Big balance pass over all the Survivors
	- Less useless skill options, default Commando is good now!
	- General power level is meant to be closer to later RoR2 survivors.
- Drone performance now remains the same on all stages.

## Other Changes

- Combat Shrines give less money, but drop items for the team on completion.
- Teleporter radius expands once the boss is dead.
- Tweaked Commencement
	- Only 2 pillars are required to activate the jump pads.
	- Pillars drop items for the team on completion, and you can complete as many as you want.
- Void Fields is shorter and progresses 2 waves at a time.

## Installation
Place RiskyMod.dll **AND** the **language folder** in /Risk of Rain 2/BepInEx/plugins/RiskyMod
	
## For Developers

To make custom allies compatible with RiskyMod's ally changes, use these items located in AllyItems.cs:

- AllyMarkerItem makes the holder benefit from Ally damage resistances. No effect when stacked.
- AllyScalingItem changes level scaling from +30% HP +20% damage -> +20% HP +30% damage so that allies perform the same on all stages. No effect when stacked.
- AllyRegenItem makes the holder's HP regenerate to full in X seconds, X being the amount of stacks.
- AllyAllowVoidDeathItem makes the holder to bypass the "No Void Death" config option.
- AllyAllowOverheatDeathItem makes the holder to bypass the "No Overheat" config option.
- AllyResistAoEItem enables the ResistantToAoE bodyflag on the holder, granting them +300 armor against attacks with DamageType.AoE

These are always initialized even if Ally changes are disabled and their effects have config-checking built-in, so you can simply add them to your allies without having to worry about anything.

Make sure these are only given to Player-team allies, since they'll be painful to fight against (in a bad/unintuitive way) when they're given to enemies.
	
## Credits

Drone Targeting fix - ZetTweaks

Squid Polyp Distraction - DestroyedClone

Language Support - Anreol

Skill Icons - KoobyKarasu

Acrid Hitbox Tweaks - TheTimesweeper

Buff Icons - SOM, VALE-X

CN Translation - JunJun_W

/vm/ (formerly /v/)

## Changelog

*Full changelog included in the .zip*

`1.2.7`

- Fixed Ocular HUD changes not working.

`1.2.6`

- Fixed Brainstalks running its changes when disabled in the config.
	- If you know of any other bugs like this, report it on the GitHub!

`1.2.5`

- Huntress
	- Flurry attack speed fix now actually works.
- Converted most On.RoR2.Run.Start and On.RoR2.Stage.Start hooks to use the proper delegates provided by the game.
	- This is an internal change that improves mod compatibility.

`1.2.4`

- Remembered to add config for toggling MoreDrones compat.

`1.2.3`

- Ally Changes
	- Added MoreDrones compat.
	- Gunner Drones and Missile Drones now attempt to prioritize the AI's current selected enemy if possible.
		- This is for compatibility with ChensMinionRetarget, since their reworked targeting was ignoring it.

`1.2.2`

- Vengeance clones are now immune to fall damage.

`1.2.1`

- Freeze Execute no longer works on player-controlled entities.

`1.2.0`

- Survivors
	- Commando
		- Frag Grenade
			- Reduced max damage falloff from -75% -> -50%
			- Increased blast radius from 11m -> 12m
			- Now has a separate Scepter state.
				- Throw multiple grenades for 5x700% damage.
			
			*This skill was feeling a bit redundant with Phase Round lightning and Suppressive Fire AoE.*
			
		- Engineer
			- Pressure Mines
				- Fixed skill description still getting changed when changes are disabled in the config.
			- Thermal Harpoons
				- Increased targeting range from 150m -> 2000m
				
		- MUL-T
			- Nailgun
				- Increased damage from 60% -> 70% (same as Vanilla)
				
				*Originally lowered it to try to encourage use of his other weapons, but in retrospect I don't think this was really necessary.*

- Items
	- Power Elixir
		- Reduced barrier gain from 100% -> 50%
		
		*Barrier gain originally got buffed because it was getting punched through super quickly in multiplayer runs. After playing around with it for a while, I've found that it's way too strong in solo while still being pretty bad in multiplayer, so the change has been reverted.*
		
	- Infusion
		- Fixed Infusion gaining orbs from Forgive Me Please.
		
	- Brilliant Behemoth
		- Removed per-stack damage scaling.
		- Extra range no longer decreases below 1.25m.
			- Old: 4, +2.5, +1.5625, +0.9766, +0.6104, etc.
			- New: 4, +2.5, +1.5625, +1.25, +1.25, etc.
		
		*Damage per stack was a holdover from earlier versions where range scaling was removed. Removing the damage scaling, and making the diminishing returns on the range scaling less severe.*
		
	- Newly-Hatched Zoea
		- Added to the Engi Turret blacklist to be consistent with Queen's Gland and Empathy Cores.
		- Stacking above 6 no longer increases ally HP since the main draw of Void allies is their death implosion.